unit Stgridm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, Keoegrid, Grids;

type
  TfMain = class(TForm)
    paTopPanel: TPanel;
    paStatusPanel: TPanel;
    imKeops: TImage;
    bbAdd: TBitBtn;
    bbDel: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    bbInsert: TBitBtn;
    bbReplace: TBitBtn;
    bbInsertEmpty: TBitBtn;
    bbClear: TBitBtn;
    bbSortString: TBitBtn;
    bbSortInteger: TBitBtn;
    bbSortFloat: TBitBtn;
    bbSortDate: TBitBtn;
    bbSortTime: TBitBtn;
    Bevel1: TBevel;
    Label3: TLabel;
    sge1: TKeoEGrid;
    bbLockCol: TBitBtn;
    bbUnlockCol: TBitBtn;
    Label4: TLabel;
    eFrom: TEdit;
    eTo: TEdit;
    Bevel2: TBevel;
    bbExit: TBitBtn;
    bbSelect: TBitBtn;
    cbErste: TCheckBox;
    cbZweite: TCheckBox;
    cbDritte: TCheckBox;
    cbVierte: TCheckBox;
    cbFuenfte: TCheckBox;
    bbLockCell: TBitBtn;
    bbUnlockCell: TBitBtn;
    bbUnlockRow: TBitBtn;
    bbSave: TBitBtn;
    bbLoad: TBitBtn;
    sbFonts: TSpeedButton;
    sbColors: TSpeedButton;
    procedure ShowHintInStatusBar(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bbExitClick(Sender: TObject);
    procedure paTopPanelResize(Sender: TObject);
    procedure bbAddClick(Sender: TObject);
    procedure bbDelClick(Sender: TObject);
    procedure bbSelectClick(Sender: TObject);
    procedure bbInsertClick(Sender: TObject);
    procedure bbReplaceClick(Sender: TObject);
    procedure bbInsertEmptyClick(Sender: TObject);
    procedure bbClearClick(Sender: TObject);
    procedure bbSortStringClick(Sender: TObject);
    procedure bbSortIntegerClick(Sender: TObject);
    procedure bbSortFloatClick(Sender: TObject);
    procedure bbSortDateClick(Sender: TObject);
    procedure bbSortTimeClick(Sender: TObject);
    procedure bbLockColClick(Sender: TObject);
    procedure bbUnlockColClick(Sender: TObject);
    procedure bbLockCellClick(Sender: TObject);
    procedure bbUnlockCellClick(Sender: TObject);
    procedure cbErsteClick(Sender: TObject);
    procedure bbUnlockRowClick(Sender: TObject);
    procedure sge1GetDrawValues(Sender: TObject; col, row: Integer;
      var aFont: TFont; var aAlignment: TAlignment; var bgColor: TColor);
    procedure bbSaveClick(Sender: TObject);
    procedure bbLoadClick(Sender: TObject);
    procedure sbFontsClick(Sender: TObject);
    procedure sbColorsClick(Sender: TObject);
  protected
  private
    FontList: TStrings;
    function F: Integer;
    function T: Integer;
  public
  end;


const
  Colores: array[0..5] of TColor = (clYellow, clAqua, clRed, clLime, clFuchsia, clSilver);
var
  fMain: TfMain;

implementation

{$R *.DFM}


{=====================================================================ALLGEMEINE ROUTINEN}
procedure TfMain.ShowHintInStatusBar(Sender: TObject);
begin
  if Application.Hint <> '' then paStatusPanel.Caption := Application.Hint;
end;

function TfMain.F: Integer;
begin
  Result := StrToInt(eFrom.Text)
end;

function TfMain.T: Integer;
begin
  Result := StrToInt(eTo.Text)
end;

{============================================================KOMPONENTENBEZOGENE ROUTINEN}
procedure TfMain.FormCreate(Sender: TObject);
var I, J: Integer;
begin
  Application.OnHint := ShowHintInStatusBar;

  for I := 0 to sge1.ColCount-1 do                          {Da mal irgendwas drin steht}
    for J := 0 to sge1.RowCount-1 do sge1.Cells[I,J] := 'S' + IntToStr(I) + IntToStr(J);

  with sge1 do
  begin
    LockCell(3, 2);                           {Als Beispiel einige Zellen/Spalten sperren}
    LockCell(4, 2);
    LockCell(1, 3);
    LockCell(2, 3);
    LockCell(0, 4);
    LockCell(4, 4);
    LockRow(5);
    LockRow(6);
  end;
end;

procedure TfMain.bbExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfMain.paTopPanelResize(Sender: TObject);
begin
  imKeops.Left := paTopPanel.Width - imKeops.Width -1;
  imKeops.Height := paTopPanel.Height - 3;
end;

procedure TfMain.bbAddClick(Sender: TObject);
var S: string;
begin
  S := IntToStr(sge1.RowCount);
  sge1.AddLine(['a'+S, 'b'+S, 'c'+S, 'd'+S, 'e'+S]);
  Label4.Visible := False;
end;

procedure TfMain.bbDelClick(Sender: TObject);
begin
  sge1.DelLines(F, T);
end;

procedure TfMain.bbSelectClick(Sender: TObject);
begin
  sge1.SelectACell(F, T);
end;

procedure TfMain.bbInsertClick(Sender: TObject);
var S: string;
begin
  S := eFrom.Text;
  sge1.InsertLine(F, ['A'+S, 'B'+S, 'C'+S, 'D'+S, 'E'+S]);
end;

procedure TfMain.bbReplaceClick(Sender: TObject);
var S: string;
begin
  S := eFrom.Text;
  sge1.ReplaceLine(F, ['1-'+S, '2-'+S, '3-'+S, '4-'+S, '5-'+S]);
end;

procedure TfMain.bbInsertEmptyClick(Sender: TObject);
begin
  sge1.InsertEmptyLines(F, T);
end;

procedure TfMain.bbClearClick(Sender: TObject);
begin
  sge1.Clear;
end;

procedure TfMain.bbSortStringClick(Sender: TObject);
begin
  sge1.SortAsString(F);
end;

procedure TfMain.bbSortIntegerClick(Sender: TObject);
begin
  sge1.SortAsInteger(F);
end;

procedure TfMain.bbSortFloatClick(Sender: TObject);
begin
  sge1.SortAsFloat(F, 2);
end;

procedure TfMain.bbSortDateClick(Sender: TObject);
begin
  sge1.SortAsDate(F);
end;

procedure TfMain.bbSortTimeClick(Sender: TObject);
begin
  sge1.SortAsTime(F);
end;

procedure TfMain.bbLockColClick(Sender: TObject);
begin
  sge1.LockCol(F);
  sge1.Repaint;
end;

procedure TfMain.bbUnlockColClick(Sender: TObject);
begin
  sge1.UnLockCol(F);
  sge1.Repaint;
end;

procedure TfMain.bbLockCellClick(Sender: TObject);
begin
  sge1.LockCell(F, T);
  sge1.Repaint;
end;

procedure TfMain.bbUnlockCellClick(Sender: TObject);
begin
  sge1.UnLockCell(F, T);
  sge1.Repaint;
end;

procedure TfMain.cbErsteClick(Sender: TObject);
begin
  with Sender as TCheckBox do
  begin
    if Checked then sge1.ShowCol(Tag)
    else sge1.HideCol(Tag);
  end;
  sge1.SetFocus;
end;

procedure TfMain.bbUnlockRowClick(Sender: TObject);
begin
  sge1.UnLockRow(F);
  sge1.Repaint;
end;

procedure TfMain.sge1GetDrawValues(Sender: TObject; col, row: Integer;
  var aFont: TFont; var aAlignment: TAlignment; var bgColor: TColor);
begin
  if sge1.IsCellLocked(Col, Row) then aFont.Color := clRed
  else aFont.Color := clBlack;

  if Assigned(FontList) then aFont.Name := FontList[Random(FontList.Count-1)];
  if sbColors.Down and (Row > 0) then bgColor := Colores[Random(5)]; 
end;

procedure TfMain.bbSaveClick(Sender: TObject);
begin
  sge1.SaveToFile(ChangeFileExt(Application.ExeName, '.txt'));
end;

procedure TfMain.bbLoadClick(Sender: TObject);
begin
  sge1.LoadFromFile(ChangeFileExt(Application.ExeName, '.txt'));
end;

procedure TfMain.sbFontsClick(Sender: TObject);
begin
  if sbFonts.Down then FontList := Screen.Fonts
  else FontList := nil;
  sge1.Invalidate;
end;

procedure TfMain.sbColorsClick(Sender: TObject);
begin
  sge1.Invalidate;
end;

end.
